/*
    AQTRONIX C++ Library
    Copyright 2016 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
#include "stdafx.h"
#include "JSON.h"

JSON::JSON(void)
{
}

JSON::~JSON(void)
{
}

//http://www.json.org/

CString JSON::Escape(CString text)
{
	text.Replace(_T("\\"),_T("\\\\"));
	text.Replace(_T("/"),_T("\\/"));

	text.Replace(_T("\b"),_T("\\b"));
	text.Replace(_T("\f"),_T("\\f"));
	text.Replace(_T("\n"),_T("\\n"));
	text.Replace(_T("\r"),_T("\\r"));
	text.Replace(_T("\t"),_T("\\t"));

	text.Replace(_T("\""),_T("\\\""));
	return _T("\"") + text + _T("\"");
}

CString JSON::Pair(CString key, CString value)
{
	return Escape(key) + _T(": ") + Escape(value);
}

CString JSON::Join(CString element1, CString element2)
{
	return element1 + _T(", ") + element2;
}

CString JSON::Join(CString element1, CString element2, CString element3)
{
	return element1 + _T(", ") + element2 + _T(", ") + element3;
}

CString JSON::Join(CStringList& list)
{
	POSITION pos = list.GetHeadPosition();
	CString item;
	CString ret = _T("");
	while(pos!=NULL){
		item = list.GetNext(pos);
		ret += item;
		if(pos!=NULL)
			ret += _T(", ");
	}
	
	return ret;
}

CString JSON::Object(CString members)
{
	return _T("{") + members + _T("}\r\n");
}

CString JSON::Array(CString elements)
{
	return _T("[") + elements + _T("]");
}